#!/bin/bash

function usage() {
    echo "USAGE:
    $(basename $0) /path/filename.wic.tar.gz /dev/xxx

Example:
    $(basename $0) kylinos-image.wic.tar.gz /dev/nvme0n1
    "
    exit 1
}

# 判断是否为root用户
if [ "$(id -u)" != "0" ]; then
    echo "please run as root" 1>&2
    exit 1
fi

# 判断参数个数
if [ ! $# -eq 2 ]; then
    usage
fi

IMAGE_FILE=$1
TARGET_DISK=$2

if [ -f "${IMAGE_FILE}" ]; then
    if [ -b "${TARGET_DISK}" ]; then
        parted -s ${TARGET_DISK} mktable gpt
        partprobe ${TARGET_DISK}
        tar xf ${IMAGE_FILE} -O | dd of=${TARGET_DISK} status=progress
    else
        echo "block ${TARGET_DISK} not exist!"
    fi
else
    echo "${IMAGE_FILE} not exist!"
fi
