#!/bin/bash

TARGET_SRC=${1:-src}

CONTROL_FILE="${TARGET_SRC}/DEBIAN/control"

package=$(grep "^Package: " ${CONTROL_FILE} | awk '{print $2}')
version=$(grep "^Version: " ${CONTROL_FILE} | awk '{print $2}')
architecture=$(grep "^Architecture: " ${CONTROL_FILE} | awk '{print $2}')

install_size=$(/usr/bin/du -s ${TARGET_SRC} | awk '{print $1}')
if ! grep -q "^Installed-Size:" ${CONTROL_FILE}; then
    sed -i "/^Version:/ a Installed-Size: ${install_size} kB" ${CONTROL_FILE}
else
    sed -i "/^Installed-Size/ c Installed-Size: ${install_size} kB" ${CONTROL_FILE}
fi

# echo "${package}_${version}_${architecture}"
# sudo chown -R 0:0 ${TARGET_SRC}
# dpkg -b ${TARGET_SRC} ${package}_${version}_${architecture}.deb
# sudo chown -R $UID:$UID ${TARGET_SRC}

# fakeroot 代替上面修改权限
fakeroot dpkg -b ${TARGET_SRC} ${package}_${version}_${architecture}.deb
