#!/bin/bash

# 判断是否为root用户
if [ "$(id -u)" != "0" ]; then
    echo "please run as root" 1>&2
    exit 1
fi

CONFIG_FILE=/etc/hosts
CONFIG_STRING_FLAG="# ====== kylin hosts ======"

# 如果已经配置，则移除
if grep -q "${CONFIG_STRING_FLAG}" ${CONFIG_FILE}; then
    start=$(cat -n ${CONFIG_FILE} | grep "${CONFIG_STRING_FLAG}" | awk 'NR==1' | awk '{print $1}')
    end=$(cat -n ${CONFIG_FILE} | grep "${CONFIG_STRING_FLAG}" | awk 'END {print}' | awk '{print $1}')
    if [[ $end -gt $start ]]; then
        # echo "$start -> $end"
        sed -i "${start},${end}d" ${CONFIG_FILE}
    fi
fi

cat >>${CONFIG_FILE} <<EOF
${CONFIG_STRING_FLAG}
# 172.20.191.3    distro.kylin.com
# 2023年5月31日10:32:02
172.20.191.5    distro.kylin.com
172.20.191.3    builder.kylin.com

172.20.191.4    dev.kylin.com
172.20.191.4    dev.kylinos.cn
172.20.191.4    launchpad.dev
172.20.191.4    keyserver.launchpad.dev
172.20.191.4    answers.launchpad.dev
172.20.191.4    archive.launchpad.dev
172.20.191.4    archive.dev.kylinos.cn
172.20.191.4    api.launchpad.dev
172.20.191.4    bazaar.launchpad.dev
172.20.191.4    bazaar-internal.launchpad.dev
172.20.191.4    blueprints.launchpad.dev
172.20.191.4    bugs.launchpad.dev
172.20.191.4    code.launchpad.dev
172.20.191.4    feeds.launchpad.dev
172.20.191.4    lists.launchpad.dev
172.20.191.4    ppa.launchpad.dev
172.20.191.4    ppa1.launchpad.dev
172.20.191.4    private-ppa.launchpad.dev
172.20.191.4    translations.launchpad.dev
172.20.191.4    xmlrpc-private.launchpad.dev
172.20.191.4    xmlrpc.launchpad.dev
172.20.191.4    testopenid.dev
172.20.191.22   zsk.kylin.com
172.20.191.28   pki.kylin.com
172.20.191.29   oauth.kylin.com
172.17.50.104   pm.kylin.com
#172.17.66.192  pm.kylin.com
172.20.191.209  gitlab2.kylin.com
${CONFIG_STRING_FLAG}
EOF

cat -n ${CONFIG_FILE}
