#!/bin/bash
set -e

# 解压、修改、重新打包deb包

function usage() {
    echo -e "USAGE:
    $(basename $0) --help       # 使用帮助
    $(basename $0) -x file.deb  # 解压
    $(basename $0) -b dir       # 打包
    "

    exit 1
}

# 判断参数个数
if [ $# -eq 0 ]; then
    usage
fi

ARGS=$(getopt -a -o h,x:,m:,b: -l help,extract:,modify:,build: -- "$@")
eval set -- "${ARGS}"

while true; do
    case "$1" in
    -h | --help)
        usage
        ;;
    -x)
        DEB_NAME=$2
        ## 解包
        dpkg-deb -X ${DEB_NAME} "${DEB_NAME%.*}_rebuild/"
        ## 解压控制信息
        dpkg-deb -e ${DEB_NAME} "${DEB_NAME%.*}_rebuild/DEBIAN/"
        shift
        ;;
    -m)
        ## 修改
        echo "--> do something"
        shift
        ;;
    -b)
        ## 重新打包
        # TARGET_NAME=${DEB_NAME%.*}_rebuild.${DEB_NAME##*.}
        # echo "$DEB_NAME -> $TARGET_NAME"
        dpkg-deb -b $2
        shift
        ;;
    --)
        shift
        break
        ;;
    esac
    shift
done
