#!/bin/bash
set -e

function usage() {
    echo -en "
    # 本地到远程
    VK_TYPE=l2r
    # 远程到本地
    VK_TYPE=r2l

    # dir
    VK_SRC_DIR_NAME=/data/git/gogs/work
    # file
    VK_SRC_FILE_NAME=/home/kylin/deb.list

    # 是否同步.git目录
    VK_RSYNC_GIT=yes

    # 241 飞腾铁机器
    VK_TARGET_USER=kylin VK_REMOTE_HOST=172.29.157.241 VK_TARGET_PORT=22

    # lenovo
    VK_TARGET_USER=zhen VK_REMOTE_HOST=172.29.157.20 VK_TARGET_PORT=22
    # 245 docker
    VK_TARGET_USER=zhen VK_REMOTE_HOST=172.29.157.245 VK_TARGET_PORT=22222
    # home workstation
    VK_TARGET_USER=zhen VK_REMOTE_HOST=s.xiayishusheng.com VK_TARGET_PORT=10022
    # home m73
    VK_TARGET_USER=zhen VK_REMOTE_HOST=s.xiayishusheng.com VK_TARGET_PORT=3022
"

    exit 1
}

# 判断参数个数
if [ $# -eq 0 ]; then
    usage
fi

for item in $*; do
    if grep -q "^VK.*=" <<<"${item}"; then
        KEY=${item%%=*}
        VALUE="${item##*=}"
        eval "export ${KEY}='${VALUE}'"
    fi
done

set | grep "^VK_"

if [ -z "${VK_TARGET_USER}" ] || [ -z "${VK_REMOTE_HOST}" ]; then
    usage
fi

if [ "${VK_RSYNC_GIT}" = "yes" ]; then
    VK_OPTIONS=" "
else
    VK_OPTIONS="--exclude=.git"
fi

VK_TYPE="${VK_TYPE:-l2r}"

# 本地 -> 远程
if [ "${VK_TYPE}" = "l2r" ]; then
    if [ -n "${VK_SRC_FILE_NAME}" ]; then
        ## file
        echo rsync ${VK_OPTIONS} -e "'ssh -p ${VK_TARGET_PORT:-22}'" -avrR "${VK_SRC_FILE_NAME}" "${VK_TARGET_USER}"@"${VK_REMOTE_HOST}":/
    elif [ -n "${VK_SRC_DIR_NAME}" ]; then
        ## dir
        echo rsync ${VK_OPTIONS} -e "'ssh -p ${VK_TARGET_PORT:-22}'" -avrR "${VK_SRC_DIR_NAME}"/./ "${VK_TARGET_USER}"@"${VK_REMOTE_HOST}":"${VK_SRC_DIR_NAME}"/
    fi
# 远程 -> 本地
elif [ "${VK_TYPE}" = "r2l" ]; then
    if [ -n "${VK_SRC_FILE_NAME}" ]; then
        ## file
        echo rsync ${VK_OPTIONS} -e "'ssh -p ${VK_TARGET_PORT:-22}'" -avrR "${VK_TARGET_USER}"@"${VK_REMOTE_HOST}":"${VK_SRC_FILE_NAME}" /
    elif [ -n "${VK_SRC_DIR_NAME}" ]; then
        ## die
        echo rsync ${VK_OPTIONS} -e "'ssh -p ${VK_TARGET_PORT:-22}'" -avrR "${VK_TARGET_USER}"@"${VK_REMOTE_HOST}":"${VK_SRC_DIR_NAME}"/./ "${VK_SRC_DIR_NAME}"/
    fi
fi
