#!/bin/bash

function usage() {
    echo -en "USAGE:
$(basename "$0") VK_IP=172.29.157.16 VK_USER=kylin
$(basename "$0") VK_IP=172.29.157.231 VK_USER=kylin
$(basename "$0") VK_IP=172.29.157.245 VK_USER=kylin

$(basename "$0") VK_IP=172.29.157.20 VK_USER=zhen VK_MOUNT_SRC=/data VK_MOUNT_POINT=/media/data
"
    exit 1
}

# 判断参数个数
if [ $# -eq 0 ]; then
    usage
fi

for item in "$@"; do
    if grep -q "^VK_.*=" <<<"${item}"; then
        KEY=${item%%=*}
        VALUE="${item##*=}"
        eval "export ${KEY}='${VALUE}'"
    fi
done

if [ -z "${VK_IP}" ] || [ -z "${VK_USER}" ]; then
    usage
fi

VK_MOUNT_SRC=${VK_MOUNT_SRC:-/}
VK_MOUNT_POINT=${VK_MOUNT_POINT:-/media/$VK_IP}
[ -d "${VK_MOUNT_POINT}" ] || sudo mkdir -p ${VK_MOUNT_POINT}

VK_USER=${VK_USER:-kylin}
echo sudo sshfs -o allow_other -o StrictHostKeyChecking=no ${VK_USER}@${VK_IP}:${VK_MOUNT_SRC} ${VK_MOUNT_POINT}

# mount | grep "${VK_IP}"
