#!/bin/bash

function usage() {
    echo -e "USAGE:
    $(basename $0) --help
    $(basename $0) /path/disk.img mount|umount
    "
    exit 111
}

# 判断参数个数
if [ $# -ne 2 ]; then
    usage
fi

# 磁盘文件名
IMAGE_FILE="$1"
disk_path=$(readlink -f "${IMAGE_FILE}")
LOOP_DEV=$(losetup -l -O NAME,BACK-FILE | grep "${disk_path}" | awk '{print $1}')

if [ -z "${LOOP_DEV}" ]; then
    LOOP_DEV=$(sudo losetup -f)
    # 将镜像关联到loop设备上
    sudo losetup -P ${LOOP_DEV} "${IMAGE_FILE}"
    # sudo partprobe ${LOOP_DEV}
fi

if [ -n "${LOOP_DEV}" ]; then
    echo "${LOOP_DEV}"
else
    echo "no loop_dev"
    exit 11
fi

function mount() {
    for p in $(lsblk -l ${LOOP_DEV} | grep "$(basename ${LOOP_DEV})p" | awk '{print $1}'); do
        mkdir -p ${p}
        mountpoint -q ${p} || sudo mount /dev/${p} ${p}
    done
}

function umount() {
    for p in $(lsblk -l ${LOOP_DEV} | grep "$(basename ${LOOP_DEV})p" | awk '{print $1}'); do
        mountpoint -q ${p} && sudo umount ${p}
        rmdir -p ${p}
    done
    sudo losetup -d ${LOOP_DEV}
}

$2
